//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers  2
#property indicator_color1   LimeGreen
#property indicator_color2   PaleVioletRed

//
//
//
//
//

extern int    RsiPeriod = 14;
extern int    RsiPrice  = PRICE_TYPICAL;
extern double LevelUp1  = 70;
extern double LevelUp2  = 70;
extern double LevelDn2  = 30;
extern double LevelDn1  = 30;

//
//
//
//
//

double trup[];
double trdn[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,trup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,trdn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
   IndicatorShortName("RSI swings ("+RsiPeriod+")");
   return(0);
}
 
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      for(int i = limit; i >= 0; i--)
      {
         double rsi = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
            trend[i] = trend[i+1];
            if (rsi<LevelDn2 && trend[i+1] ==  1) trend[i] =  0;
            if (rsi>LevelUp2 && trend[i+1] == -1) trend[i] =  0;
            if (rsi>LevelUp1)                     trend[i] =  1;
            if (rsi<LevelDn1)                     trend[i] = -1;

            //
            //
            //
            //
            //
            
            trup[i] = EMPTY_VALUE;
            trdn[i] = EMPTY_VALUE;
               if (trend[i] ==  1) { trup[i] =  High[i]; trdn[i] = Low[i]; }
               if (trend[i] == -1) { trdn[i] =  High[i]; trup[i] = Low[i]; }
      }
      return(0);
}